//
// Dash to Dock
//

// Scrollview style
.bottom #dashtodockDashScrollview,
.top #dashtodockDashScrollview {
  -st-hfade-offset: 24px;
}

.left #dashtodockDashScrollview,
.right #dashtodockDashScrollview {
  -st-vfade-offset: 24px;
}

#dashtodockContainer {
  background: transparent;

  .number-overlay {
    color: white;
    background-color: rgba(black, 0.75);
    text-align: center;
  }

  .notification-badge {
    color: $light_fg_color;
    background-color: $primary_color;
    box-shadow: 0 2px 3px 0 rgba(0, 0, 0, 0.25);
    border-radius: $circular_radius;
    margin: 2px 3px 5px;
    padding: 0.2em 0.6em;
    font-weight: bold;
    text-align: center;
  }

  @each $_pos, $b_pos in (top, bottom),
                         (bottom, top),
                         (left, right),
                         (right, left) {
    &.#{$_pos}.straight-corner,
    &.#{$_pos}.shrink.straight-corner,
    &.#{$_pos}.extended,
    &.#{$_pos}.shrink.extended {
      &, #dash {
        margin: 0 !important;
        margin-top: 0 !important;
        padding: 0 !important;
      }

      .dash-background {
        margin: 0 !important;
        margin-bottom: 0 !important;
        border-radius: 0;
      }

      .dash-item-container .app-well-app, .show-apps {
        margin: 0 !important;
      }
    }
  }

  &.extended,
  &.straight-corner {
    .dash-background {
      border-radius: 0;
    }
  }

  &.shrink {
    .dash-background {
      padding: $dash_spacing !important;
      // border-radius: $buttons_radius + $container_padding / 2;
    }

    .dash-item-container .app-well-app, .show-apps {
      margin: 0 !important;
    }
  }

  &.shrink.extended {
    .dash-background {
      border-radius: 0;
    }
  }

  #dash,
  &:overview #dash {
    background: transparent;
  }

  &.left,
  &.right {
    .dash-item-container .app-well-app, .show-apps {
      padding: $dash_spacing $container_padding !important;
    }

    .dash-background {
      margin-bottom: 0 !important;
    }

    &.shrink, &.shrink.extended {
      .dash-background {
        padding: $container_margin / 2 $container_margin !important;
      }

      .dash-item-container .app-well-app, .show-apps {
        margin: 0 !important;
        padding: $container_margin / 2 0 !important;
      }
    }

    &.extended,
    &.straight-corner {
      .dash-item-container .app-well-app {
        padding: $dash_spacing $dash_padding !important;
      }

      .show-apps {
        padding: $dash_spacing $dash_padding $dash_padding * 2 !important;
      }
    }
  }

  &.top,
  &.bottom {
    .dash-background {
      padding: $dash_padding ($dash_padding - $dash_spacing) !important;
    }

    &.shrink {
      .dash-background {
        padding: $container_margin $container_margin / 2 !important;
      }

      .dash-item-container .app-well-app, .show-apps {
        margin: 0 !important;
        padding: 0 $container_margin / 2 $dash_bottom_margin !important;
      }
    }

    &.extended,
    &.straight-corner {
      .dash-separator {
        margin: 0 ($dash_spacing + ($dash_padding / 2)) !important;
      }

      .dash-item-container .app-well-app, .show-apps {
        padding: $dash_padding $dash_spacing !important;
      }
    }
  }

  #dash {
    .dash-background {
      background-color: $panel_bg_color;
    }

    StWidget.focused .app-well-app-running-dot {
      background-color: $primary_color;
    }
  }

  &.opaque #dash .dash-background { // solid-mode
    background-color: $panel_bg;
  }

  &.transparent #dash .dash-background { // translucent-mode
    background-color: $panel_bg_color; // does not work
  }

  &:overview #dash { // overview-mode #1
    background: none;

    .dash-background {
      background-color: $inverse_divider_color;
    }

    StWidget.focused .app-well-app-running-dot {
      background-color: $primary_color;
    }
  }

  &.opaque:overview,
  &.transparent:overview { // overview-mode #2
    #dash {
      background-color: transparent !important;
      box-shadow: none !important;
    }

    .dash-background {
      background-color: transparent !important;
    }
  }

  &.extended:overview, // overview-mode #3
  &.opaque.extended:overview,
  &.transparent.extended:overview {
    #dash {
      background: none;
    }
  }

  &.running-dots,
  &.dashtodock {
    .dash-item-container > StButton {
      transition-duration: 250ms;
      background-size: contain;
    }
  }

  &.shrink,
  &.dashtodock {
    .dash-item-container > StButton {
      padding: 1px 2px;
    }
  }

  &.extended,
  &.extended:overview {
    .app-well-app,
    .show-apps {
      .overview-icon {
        border-radius: $buttons_radius;
      }
    }
  }

  .metro .overview-icon {
    border-radius: 0;
  }
}

.dashtodock-app-well-preview-menu-item {
  padding: 1em 1em 0.5em 1em;
}

#dashtodockPreviewSeparator.popup-separator-menu-item-horizontal {
  width: 1px;
  height: auto;
  border-right-width: 1px;
  margin: 32px 0;
}

//
// OpenWeather
//

.openweather {
  &-button,
  &-button-action,
  &-menu-button-container,
  &-button-box {
    border: 1px solid transparent;
  }

  &-provider {
    // generic text buttons are allocated with y-expand-ed
    padding: 0 16px;
    font-weight: 500;
    @include button(flat-normal);
    &:hover { @include button(flat-hover); }
    &:focus { @include button(flat-focus); }
    &:active { @include button(flat-active); }
    &:insensitive { @include button(flat-disabled); }
  }

  &-current {
    &-icon,
    &-summary,
    &-summarybox {
      background: none;
      color: $fg_color;
    }

    &-databox-values {
      background: none;
      color: $hint_fg_color;
    }

    &-databox-captions {
      background: none;
      color: $hint_fg_color;
    }
  }

  &-forecast {
    &-icon,
    &-summary {
      background: none;
      color: $secondary_fg_color;
    }

    &-day,
    &-temperature {
      background: none;
      color: $hint_fg_color;
    }
  }

  &-sunrise-icon,
  &-sunset-icon,
  &-build-icon { color: $secondary_fg_color; }
}

.popup-sub-menu .openweather {
  &-current {
    &-icon,
    &-summary,
    &-summarybox {
      background: none;
      color: rgba(black, 0.95);
    }

    &-databox-values {
      color: rgba(black, 0.75);
    }

    &-databox-captions {
      color: rgba(black, 0.75);
    }
  }

  &-forecast {
    &-icon,
    &-summary {
      color: rgba(black, 0.85);
    }

    &-day,
    &-temperature {
      color: rgba(black, 0.75);
    }
  }

  &-sunrise-icon,
  &-sunset-icon,
  &-build-icon { color: rgba(black, 0.85); }
}

//
// Pop_OS cosmic widget styling
//

.cosmic-solid-bg {
  background-color: $system_bg_color;
}

.cosmic-dock {
  #dock {
    background-color: transparent;

    .dash-background {
      background-color: $panel_bg_color;
    }
  }

  &.extended {
    #dash {
      margin-left: 0;
      margin-right: 0;
      margin-top: 0;
      margin-bottom: 0;
      padding: 0 0;

      .dash-background {
        border-radius: 0;
        margin-left: 0;
        margin-right: 0;
        margin-top: 0;
        margin-bottom: 0;
      }
    }
  }
}
